<?php

require_once __DIR__.'/../../../../../projects/scheduler/public/bootstrap.php';
require_once __DIR__.'/../../Entities/TkuProcessQueue.php';
require_once __DIR__.'/../MailSender.php';
require_once __DIR__.'/../ReportSender.php';
require_once __DIR__.'/../ProcedureRunner.php';

$db = \Setforms2\Runtime\Connection::getInstance();
$get_servers="SELECT SERVER_ADDRESS, PORT FROM TKU_PROCESS_MANAGER";
$array_servidores=$db->fetchAll($get_servers);
$success=false;
if ($array_servidores){
//    echo "t2";
    $worker = new GearmanWorker();
    foreach ($array_servidores as $servidor){
        try{
            $result=$worker->addServer($servidor["SERVER_ADDRESS"], $servidor["PORT"]);
            $success=$result||$success;
        }catch(GearmanException $e){
            echo $e->getMessage();
            echo "\nO IP $servidor[SERVER_ADDRESS] nao pode ser registrado";
        }
    }
}
else{
    die("Nenhum servidor foi encontrado. Favor verificar.");
}
//echo "test";
if ($success===false) {echo "Nao ha gerenciadores disponiveis"; exit;}

$worker->addFunction("send_email", function ($job){
        try{
            $workload=$job->workload();
            $nrorg=array_pop($workload);
            $params=array_pop($workload);

            \Scheduler\Logic\MailSender::mandar_email($params,$nrorg);
        }catch(Exception $e){
            $job->sendException($e->getMessage());
            \Scheduler\Logic\MailSender::sendErrorEmail("send_email - ".$e->getMessage());
        }
    }
);

$worker->addFunction("send_report", function ($job){
        try{

            $workload=$job->workload();
            $nrorg=array_pop($workload);
            $params=array_pop($workload);

            \Scheduler\Logic\ReportSender::mandar_relatorio($params,$nrorg);
        }catch(Exception $e){
            $job->sendException($e->getMessage());
            \Scheduler\Logic\MailSender::sendErrorEmail("send_report - ".$e->getMessage());
        }
    }
);

$worker->addFunction("run_procedure", function ($job){
        try{

            $workload=$job->workload();
            $nrorg=array_pop($workload);
            $params=array_pop($workload);

            \Scheduler\Logic\ProcedureRunner::executa_procedure($params,$nrorg);
        }catch(Exception $e){
            $job->sendException($e->getMessage());
            \Scheduler\Logic\MailSender::sendErrorEmail("runProcedure - ".$e->getMessage());
        }
    }
);
echo "Starting worker!";
while($worker->work());
echo "Worker finished!";

?>
